signature IMPAST = sig

  type loc = string

  datatype Aexp = 
    N of int 
  | Loc of loc
  | Plus of Aexp * Aexp
  | Minus of Aexp * Aexp
  | Times of Aexp * Aexp

  datatype Bexp =
    True
  | False
  | Equals of Aexp * Aexp
  | LessEq of Aexp * Aexp
  | Not of Bexp
  | And of Bexp * Bexp
  | Or of Bexp * Bexp
  | Implies of Bexp * Bexp 

  datatype Com =
    Skip
  | Assign of loc * Aexp
  | Seq of Com * Com
  | Cond of Bexp * Com * Com
  | While of Bexp * Bexp * Com    (* while{D}(b)do{c} = While(D, b, c)     *)
  | DoUntil of Com * Bexp * Bexp  (* do{c}until{D}(b) = DoUntil(c, D, b)   *)

  datatype Program =
    AnnotatedProg of Bexp * Com * Bexp (* {A}c{B} = AnnotatedProg(A, c, B) *)

end
