structure Imp = Interpretation(ImpAst)
structure PP = PPrint(ImpAst)
structure Verify = Verification(ImpAst)

fun run f = 
  let 
    val prog = Parser.parse f
    val _ = PP.pprintProgram prog
    val _ = print "\n"
    val ImpAst.AnnotatedProg(a1, com, a2) = prog
    val state = Imp.interpret(com, Imp.initialState)
  in
    Imp.lookupState(state, "ANSWER")
  end

fun test f = 
  let 
    val prog = Parser.parse f
    val _ = PP.pprintProgram prog
    val _ = print "\n\nVerification conditions:\n"
    val vc = Verify.VC(prog)
    val _ = PP.pprintBexp vc
    val vc' = Verify.rewriteAssn(vc)
    val _ = print "\n\nRewritten vc:\n"
    val _ = PP.pprintBexp vc'
    val _ = print "\n"
  in
    ()
  end

